; ====================================================================
; -----------------------------------------------------------------
; Header
; -----------------------------------------------------------------

		include	"mars/sh2/shmap68k.i"
		include "mars/mars.i"
		
		org 0
		dc.l $FFFE00
		dc.l $3F0
		cnop 0,$70
                dc.l PalToCRAM-marsipl
		cnop 0,$78
                dc.l loc_B10-marsipl

		cnop 0,$100
		dc.b "SEGA 32X        "
		cnop 0,$110
		dc.b "(C)???? ????.???"
                cnop 0,$120
                dc.b "MARS                                            "
                cnop 0,$150
                dc.b "MARS                                            "
                dc.b "GM ????????-00"
                cnop 0,$190
		dc.b "J               "

		dc.l 0
		dc.l EndOfRom
		dc.l $FF0000
		dc.l $FFFFFF
		dc.b "RA",$E8,$20
		dc.l $200000
		dc.l $203FFF

		cnop 0,$1F0
		dc.b "U               "

; ----------------------------------------
; MARS vector
; ----------------------------------------

                cnop 0,$200
		jmp	EntryPoint
		cnop 0,$2A2
		jmp	PalToCRAM
		cnop 0,$2AE
		jmp	loc_B10
		
; ----------------------------------------
; MARS User Header
; ----------------------------------------

		cnop 0,$3C0
		dc.b "MODULE NAME     "
		dc.l 0
		dc.l SH2_Start
		dc.l 0
		dc.l SH2_End-SH2_Start
		dc.l MasterStart+$120				; Master SH2 initial PC
		dc.l SlaveStart+$120				; Slave SH2 initial PC
		dc.l MasterStart				; Master SH2 initial VBR address
		dc.l SlaveStart					; Slave SH2 intitial VBR address
	
		incbin	"mars/security.bin"
		
; ----------------------------------------
; Finished checking
; ----------------------------------------

 		bcs	@NoMars
 
; ----------------------------------------
; Init already...
; ----------------------------------------

@init:
		move	#$2700,sr
		lea	(marsreg),a5
		
@M_OK:		cmp.l	#'M_OK',$20(a5)
		bne	@M_OK
@S_OK:		cmp.l	#'S_OK',$24(a5)
		bne	@S_OK

		moveq	#0,d0
		move.l	d0,$20(a5)
		move.l	d0,$24(a5)
 		jmp	EntryPoint
 		
; ===========================================================================
; ----------------------------------------
; 32x not inserted
; ----------------------------------------

@NoMars:
		move.w	#$2700,sr
		
		move.l	#$C0000000,($C00004).l
		move.w	#$0E00,($C00000).l
		bra.s	*
		